using System;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using CallCenterApi.DB;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_SMS_List
    /// </summary>
    public partial class T_SMS_List
    {
        public T_SMS_List()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int ID)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_SMS_List");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@ID", SqlDbType.Int,4)
            };
            parameters[0].Value = ID;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_SMS_List model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_SMS_List(");
            strSql.Append("Type,SendWay,DSSendTime,SendTime,IsSend,Telephone,Detail,MBID,MID,MName,CreateDate,BatchNo)");
            strSql.Append(" values (");
            strSql.Append("@Type,@SendWay,@DSSendTime,@SendTime,@IsSend,@Telephone,@Detail,@MBID,@MID,@MName,@CreateDate,@BatchNo)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@Type", SqlDbType.Int,4),
                    new SqlParameter("@SendWay", SqlDbType.Int,4),
                    new SqlParameter("@DSSendTime", SqlDbType.DateTime),
                    new SqlParameter("@SendTime", SqlDbType.DateTime),
                    new SqlParameter("@IsSend", SqlDbType.Int,4),
                    new SqlParameter("@Telephone", SqlDbType.VarChar,20),
                    new SqlParameter("@Detail", SqlDbType.VarChar,-1),
                    new SqlParameter("@MBID", SqlDbType.Int,4),
                    new SqlParameter("@MID", SqlDbType.VarChar,50),
                    new SqlParameter("@MName", SqlDbType.VarChar,50),
                    new SqlParameter("@CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@BatchNo", SqlDbType.VarChar,50)};
            parameters[0].Value = model.Type;
            parameters[1].Value = model.SendWay;
            parameters[2].Value = model.DSSendTime;
            parameters[3].Value = model.SendTime;
            parameters[4].Value = model.IsSend;
            parameters[5].Value = model.Telephone;
            parameters[6].Value = model.Detail;
            parameters[7].Value = model.MBID;
            parameters[8].Value = model.MID;
            parameters[9].Value = model.MName;
            parameters[10].Value = model.CreateDate;
            parameters[11].Value = model.BatchNo;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_SMS_List model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_SMS_List set ");
            strSql.Append("Type=@Type,");
            strSql.Append("SendWay=@SendWay,");
            strSql.Append("DSSendTime=@DSSendTime,");
            strSql.Append("SendTime=@SendTime,");
            strSql.Append("IsSend=@IsSend,");
            strSql.Append("Telephone=@Telephone,");
            strSql.Append("Detail=@Detail,");
            strSql.Append("MBID=@MBID,");
            strSql.Append("MID=@MID,");
            strSql.Append("MName=@MName,");
            strSql.Append("CreateDate=@CreateDate,");
            strSql.Append("BatchNo=@BatchNo");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@Type", SqlDbType.Int,4),
                    new SqlParameter("@SendWay", SqlDbType.Int,4),
                    new SqlParameter("@DSSendTime", SqlDbType.DateTime),
                    new SqlParameter("@SendTime", SqlDbType.DateTime),
                    new SqlParameter("@IsSend", SqlDbType.Int,4),
                    new SqlParameter("@Telephone", SqlDbType.VarChar,20),
                    new SqlParameter("@Detail", SqlDbType.VarChar,-1),
                    new SqlParameter("@MBID", SqlDbType.Int,4),
                    new SqlParameter("@MID", SqlDbType.VarChar,50),
                    new SqlParameter("@MName", SqlDbType.VarChar,50),
                    new SqlParameter("@CreateDate", SqlDbType.DateTime),
                    new SqlParameter("@BatchNo", SqlDbType.VarChar,50),
                    new SqlParameter("@ID", SqlDbType.Int,4)};
            parameters[0].Value = model.Type;
            parameters[1].Value = model.SendWay;
            parameters[2].Value = model.DSSendTime;
            parameters[3].Value = model.SendTime;
            parameters[4].Value = model.IsSend;
            parameters[5].Value = model.Telephone;
            parameters[6].Value = model.Detail;
            parameters[7].Value = model.MBID;
            parameters[8].Value = model.MID;
            parameters[9].Value = model.MName;
            parameters[10].Value = model.CreateDate;
            parameters[11].Value = model.BatchNo;
            parameters[12].Value = model.ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_SMS_List ");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@ID", SqlDbType.Int,4)
            };
            parameters[0].Value = ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_SMS_List ");
            strSql.Append(" where ID in (" + IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_SMS_List GetModel(int ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 ID,Type,SendWay,DSSendTime,SendTime,IsSend,Telephone,Detail,MBID,MID,MName,CreateDate,BatchNo from T_SMS_List ");
            strSql.Append(" where ID=@ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@ID", SqlDbType.Int,4)
            };
            parameters[0].Value = ID;

            CallCenterApi.Model.T_SMS_List model = new CallCenterApi.Model.T_SMS_List();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_SMS_List DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_SMS_List model = new CallCenterApi.Model.T_SMS_List();
            if (row != null)
            {
                if (row["ID"] != null && row["ID"].ToString() != "")
                {
                    model.ID = int.Parse(row["ID"].ToString());
                }
                if (row["Type"] != null && row["Type"].ToString() != "")
                {
                    model.Type = int.Parse(row["Type"].ToString());
                }
                if (row["SendWay"] != null && row["SendWay"].ToString() != "")
                {
                    model.SendWay = int.Parse(row["SendWay"].ToString());
                }
                if (row["DSSendTime"] != null && row["DSSendTime"].ToString() != "")
                {
                    model.DSSendTime = DateTime.Parse(row["DSSendTime"].ToString());
                }
                if (row["SendTime"] != null && row["SendTime"].ToString() != "")
                {
                    model.SendTime = DateTime.Parse(row["SendTime"].ToString());
                }
                if (row["IsSend"] != null && row["IsSend"].ToString() != "")
                {
                    model.IsSend = int.Parse(row["IsSend"].ToString());
                }
                if (row["Telephone"] != null)
                {
                    model.Telephone = row["Telephone"].ToString();
                }
                if (row["Detail"] != null)
                {
                    model.Detail = row["Detail"].ToString();
                }
                if (row["MBID"] != null && row["MBID"].ToString() != "")
                {
                    model.MBID = int.Parse(row["MBID"].ToString());
                }
                if (row["MID"] != null)
                {
                    model.MID = row["MID"].ToString();
                }
                if (row["MName"] != null)
                {
                    model.MName = row["MName"].ToString();
                }
                if (row["CreateDate"] != null && row["CreateDate"].ToString() != "")
                {
                    model.CreateDate = DateTime.Parse(row["CreateDate"].ToString());
                }
                if (row["BatchNo"] != null)
                {
                    model.BatchNo = row["BatchNo"].ToString();
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ID,Type,SendWay,DSSendTime,SendTime,IsSend,Telephone,Detail,MBID,MID,MName,CreateDate,BatchNo ");
            strSql.Append(" FROM T_SMS_List ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" ID,Type,SendWay,DSSendTime,SendTime,IsSend,Telephone,Detail,MBID,MID,MName,CreateDate,BatchNo ");
            strSql.Append(" FROM T_SMS_List ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_SMS_List ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_SMS_List T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_SMS_List";
			parameters[1].Value = "ID";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}

